#if 0
<--/****************************************
Automatic Performance Tuning for DGEMV -T
2015年  4月 12日 日曜日 00:47:42 JST
Host on pascal.aics27.riken.jp
Device is Tesla-K20c
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="pascal.aics27.riken.jp";
char* _AT_tuned_device="Tesla-K20c";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(13)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_DGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_4	1
#define	KERNEL_6	1
#define	KERNEL_10	1
#define	KERNEL_11	1
#define	KERNEL_12	1
#define	KERNEL_0	1
#define	KERNEL_1	1
#define	KERNEL_15	1
#define	KERNEL_2	1
#define	KERNEL_16	1
#define	KERNEL_3	1

if ( n >= 1 && n < 296 ) {
	BLK = 6;
} else
if ( n >= 296 && n < 384 ) {
	BLK = 10;
} else
if ( n >= 384 && n < 427 ) {
	BLK = 4;
} else
if ( n >= 427 && n < 676 ) {
	BLK = 16;
} else
if ( n >= 676 && n < 1040 ) {
	BLK = 10;
} else
if ( n >= 1040 && n < 1352 ) {
	BLK = 16;
} else
if ( n >= 1352 && n < 1560 ) {
	BLK = 12;
} else
if ( n >= 1560 && n < 1664 ) {
	BLK = 3;
} else
if ( n >= 1664 && n < 1872 ) {
	BLK = 6;
} else
if ( n >= 1872 && n < 1902 ) {
	BLK = 0;
} else
if ( n >= 1902 && n < 2028 ) {
	BLK = 16;
} else
if ( n >= 2028 && n < 2116 ) {
	BLK = 0;
} else
if ( n >= 2116 && n < 2184 ) {
	BLK = 1;
} else
if ( n >= 2184 && n < 2289 ) {
	BLK = 0;
} else
if ( n >= 2289 && n < 2340 ) {
	BLK = 1;
} else
if ( n >= 2340 && n < 2451 ) {
	BLK = 0;
} else
if ( n >= 2451 && n < 2496 ) {
	BLK = 15;
} else
if ( n >= 2496 && n < 2587 ) {
	BLK = 0;
} else
if ( n >= 2587 && n < 2652 ) {
	BLK = 15;
} else
if ( n >= 2652 && n < 2723 ) {
	BLK = 0;
} else
if ( n >= 2723 && n < 2808 ) {
	BLK = 15;
} else
if ( n >= 2808 && n < 2859 ) {
	BLK = 0;
} else
if ( n >= 2859 && n < 3276 ) {
	BLK = 15;
} else
if ( n >= 3276 && n < 16189 ) {
	BLK = 0;
} else
if ( n >= 16189 && n < 16224 ) {
	BLK = 2;
} else
if ( n >= 16224 && n < 16809 ) {
	BLK = 0;
} else
if ( n >= 16809 && n < 16848 ) {
	BLK = 2;
} else
if ( n >= 16848 && n < 17106 ) {
	BLK = 0;
} else
if ( n >= 17106 && n < 17160 ) {
	BLK = 11;
} else
if ( n >= 17160 && n < 17428 ) {
	BLK = 0;
} else
if ( n >= 17428 && n < 17472 ) {
	BLK = 2;
} else
if ( n >= 17472 && n < 17579 ) {
	BLK = 0;
} else
if ( n >= 17579 && n < 17628 ) {
	BLK = 11;
} else
if ( n >= 17628 && n < 17863 ) {
	BLK = 0;
} else
if ( n >= 17863 && n < 17940 ) {
	BLK = 11;
} else
if ( n >= 17940 && n < 18048 ) {
	BLK = 0;
} else
if ( n >= 18048 && n < 18067 ) {
	BLK = 2;
} else
if ( n >= 18067 && n < 18096 ) {
	BLK = 11;
} else
if ( n >= 18096 && n < 18146 ) {
	BLK = 0;
} else
if ( n >= 18146 && n < 18200 ) {
	BLK = 11;
} else
if ( n >= 18200 && n < 18213 ) {
	BLK = 0;
} else
if ( n >= 18213 && n < 18252 ) {
	BLK = 2;
} else
if ( n >= 18252 && n < 18336 ) {
	BLK = 0;
} else
if ( n >= 18336 && n < 18460 ) {
	BLK = 11;
} else
if ( n >= 18460 && n < 18525 ) {
	BLK = 0;
} else
if ( n >= 18525 && n < 18564 ) {
	BLK = 11;
} else
if ( n >= 18564 && n < 18619 ) {
	BLK = 0;
} else
if ( n >= 18619 && n < 18720 ) {
	BLK = 11;
} else
if ( n >= 18720 && n < 18809 ) {
	BLK = 0;
} else
if ( n >= 18809 && n < 18980 ) {
	BLK = 11;
} else
if ( n >= 18980 && n < 18998 ) {
	BLK = 0;
} else
if ( n >= 18998 && n < 18999 ) {
	BLK = 2;
} else
if ( n >= 18999 && n < 19032 ) {
	BLK = 11;
} else
if ( n >= 19032 && n < 19092 ) {
	BLK = 0;
} else
if ( n >= 19092 && n < 19240 ) {
	BLK = 11;
} else
if ( n >= 19240 && n < 19282 ) {
	BLK = 0;
} else
if ( n >= 19282 && n < 19500 ) {
	BLK = 11;
} else
if ( n >= 19500 && n < 19565 ) {
	BLK = 0;
} else
if ( n >= 19565 && n < 19812 ) {
	BLK = 11;
} else
if ( n >= 19812 && n < 19849 ) {
	BLK = 0;
} else
if ( n >= 19849 && n < 20280 ) {
	BLK = 11;
} else
if ( n >= 20280 && n < 20322 ) {
	BLK = 0;
} else
if ( n >= 20322 && n < 23827 ) {
	BLK = 11;
} else
if ( n >= 23827 && n < 100000000 ) {
	BLK = 11;
}

#if 1
	int ii=BLK;
#define DGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
		GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
		( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		DGEMVT_KERNEL_ ( 320 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		DGEMVT_KERNEL_ ( 288 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		DGEMVT_KERNEL_ ( 288 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		DGEMVT_KERNEL_ ( 64 , 4 , 8, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		DGEMVT_KERNEL_ ( 128 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		DGEMVT_KERNEL_ ( 128 , 2 , 6, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		DGEMVT_KERNEL_ ( 32 , 6 , 4, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		DGEMVT_KERNEL_ ( 32 , 5 , 4, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		DGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		DGEMVT_KERNEL_ ( 160 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		DGEMVT_KERNEL_ ( 64 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		DGEMVT_KERNEL_ ( 288 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		DGEMVT_KERNEL_ ( 64 , 3 , 8, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		DGEMVT_KERNEL_ ( 16 , 14 , 2, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		DGEMVT_KERNEL_ ( 128 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		DGEMVT_KERNEL_ ( 16 , 21 , 3, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		DGEMVT_KERNEL_ ( 96 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		DGEMVT_KERNEL_ ( 128 , 1 , 6, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		DGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		DGEMVT_KERNEL_ ( 256 , 1 , 3, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

